

#include "crc.h"

/*Описываем функцию расчёта Crc32
с применением полинома EDB88320UL=
x^32 + x^26 + x^23 + x^22 + x^16 + x^12 + x^11
+ x^10 + x^8 + x^7 + x^5 + x^4 + x^2 + x + 1*/
unsigned long Crc32(unsigned char *buf, unsigned long len)
{
	//инициализируем таблицу расчёта Crc32
	unsigned long crc_table[256];
	unsigned long crc;
	for (int i = 0; i < 256; i++)
	{
		crc = i;
		for (int j = 0; j < 8; j++)//цикл перебора полинома
			//crc = crc & 1 ? (crc >> 1) ^ 0x4C11DB7L : crc >> 1; 
			crc = crc & 1 ? (crc >> 1) ^ 0xEDB88320UL : crc >> 1;
		crc_table[i] = crc;
	};
	crc = 0xFFFFFFFFUL;
	while (len--)// проверка условия продолжения
		crc = crc_table[(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
	return crc ^ 0xFFFFFFFFUL; //конец функции расчёта Crc32
};

/*unsigned long Crc32(unsigned char *buf, unsigned long len) 
{
	int cnt = 0;
	unsigned long crc = 0;
	while(cnt < len) {
		crc += *(buf + cnt);
		cnt++;
	}
	return crc;
}*/

