//main.h

#include <stdio.h>
#include <string.h>
#include <stdint.h>

#include "config.h"
#include "main.h"
#include "udps.h"
#include "pktanalisys.h"

char 		RdNameFile[_szname];
char		strIP[_szname];
uint8_t		RdBuff[_szbuf];
int		SzRdFile;
uint8_t 	DataBuf[_szbuf];
uint8_t 	DataBuf2[_szbuf];
int		SzDataBuf;
int		SzDataBuf2;
uint16_t	mport;

int main(int argc, char **argv)
{
	int	cntc	= 1;
	if(argc < 2) {
		printf("\nНе определены параметры!!!\nПараметр: \"--help\" для подсказки.\n");
		return -1;
	}
	while(cntc < argc) {
		if(strcmp(argv[cntc], "--help") == 0) {
			printf("%s", _help);
			return 0;		
		} 
		else if(strcmp(argv[cntc], "--rdfile") == 0) {
			cntc++;
			if(cntc > argc)
				return -3;
			memset(&RdNameFile[0], 0, _szname);
			strcpy(&RdNameFile[0], argv[cntc]);
			SzRdFile = DataFromFile(&RdNameFile[0], &RdBuff[0]);
			if(SzRdFile <= 0) {
				printf("\nФайл данных не прочитан!\n");
			}
			printf("Размер данных: %i байт. Дамп:\n", SzRdFile);
			outhex(&RdBuff[0], SzRdFile);
		}
		else if(strcmp(argv[cntc], "--fileanalisys") == 0) {
			cntc++;
			if(cntc > argc)
				return -3;
			memset(&RdNameFile[0], 0, _szname);
			strcpy(&RdNameFile[0], argv[cntc]);
			SzRdFile = DataFromFile(&RdNameFile[0], &RdBuff[0]);
			if(SzRdFile <= 0) {
				printf("\nФайл данных не прочитан!\n");
				return -4;
			}
			printf("Размер данных: %i байт. Дамп:\n", SzRdFile);
			outhex(&RdBuff[0], SzRdFile);
			SzDataBuf = fDataAnalsysToConsole(&RdBuff[0], SzRdFile, &DataBuf[0]);
			outhex(&DataBuf[0], SzDataBuf);
		}
		else if(strcmp(argv[cntc], "--udprcv") == 0) {
			cntc++;
			if(cntc > argc)
				return -3;
			mport = atoi(argv[cntc]);
			printf("Приём пакета UDP по порту %i\n", mport); 
			SzDataBuf = UdpListen(mport, &DataBuf[0]);
			outhex(&DataBuf[0], SzDataBuf);
		}
		else if(strcmp(argv[cntc], "--udprcvwaitIP") == 0) {
			cntc++;
			if(cntc > argc)
				return -3;
			strcpy(&strIP[0], argv[cntc]);
			cntc++;
			if(cntc > argc)
				return -3;
			mport = atoi(argv[cntc]);
			printf("Приём пакета UDP по IP %s и по порту %i\n", &strIP[0], mport); 
			SzDataBuf = UdpListenWaitIp(&strIP[0], mport, &DataBuf[0]);
			outhex(&DataBuf[0], SzDataBuf);
		}
		else if(strcmp(argv[cntc], "--sndTCPwaitUDP") == 0) {
			cntc++;
			if(cntc > argc)
				return -3;
			memset(&RdNameFile[0], 0, _szname);
			strcpy(&RdNameFile[0], argv[cntc]);
			SzRdFile = DataFromFile(&RdNameFile[0], &RdBuff[0]);
			if(SzRdFile <= 0) {
				printf("\nФайл данных не прочитан!\n");
				return -4;
			}
			printf("Размер данных: %i байт. Дамп:\n", SzRdFile);
			outhex(&RdBuff[0], SzRdFile);
			SzDataBuf = fDataAnalsysToConsole(&RdBuff[0], SzRdFile, &DataBuf[0]);
			outhex(&DataBuf[0], SzDataBuf);
			SzDataBuf2 = UdpListenWaitIp(&strIP[0], mport - 1, &DataBuf2[0]);
			outhex(&DataBuf2[0], SzDataBuf2);
			TcpConnect(&strIP[0], mport);
			TcpLoop(&DataBuf[0], SzDataBuf);
		}
		else {
			printf("\nНе известный параметр \"%s\"!!!\nПараметр: \"--help\" для подсказки.\n", argv[cntc]);
			return -2;
		}
		cntc++;
	}
	return 0;
}


