//pktanalisys.c

#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>

#include "pktanalisys.h"
#include "main.h"

const uint8_t	datastart[]	= {0x00, 0x00, 0x55, 0xAA};
const uint8_t	tatastop[] 	= {0x00, 0x00, 0xAA, 0x55};

/* вывод дампа
*buf - начальный вдрес массива(структуры и др.)
size - размер байта для вывода
*/
void outhex(uint8_t *buf, int size)
{
    int cnt = 0, cnt2 = 0;
    printf("\n%04X: ",cnt);
    while(cnt < size) {
        if(!(cnt2 < 16)) {
            cnt2 = 0;
            printf("\n%04X: ",cnt);
        }
        printf("%02X ", (*(uint8_t*)(buf + cnt)));
        cnt2++;
        cnt++;
    }
    printf("\n");
}

//чтение данных из файла(исходный пакет)
int DataFromFile(char *FileName, uint8_t *Buf)
{
	FILE 	*file;
	int	res 	= 0;
	uint8_t	byte;
	file = fopen(FileName, "rb");
	if(file == NULL)
		return -1;
	while(1) {
		fread(&byte, sizeof(uint8_t), 1, file);
		(*(uint8_t*)(Buf + res)) = byte;
		res++;
		if(feof(file))
			break;
	}
	res--;
	fclose(file);
	return res;
}

//Анализ в консоль
//частичный разбор пакета, выделение рабочего массива
int fDataAnalsysToConsole(uint8_t *Buf, int szBuf, uint8_t *outBuf)
{
	int 		cnt;
	uint16_t	port;
	//
	printf("MAC адрес источника: ");
	cnt = 0;
	while(cnt < 5) {
		printf("%02X:", (*(uint8_t*)(Buf + _udp_macaddr_from + cnt)));
		cnt++;
	}
	printf("%02X\n", (*(uint8_t*)(Buf + _udp_macaddr_from + cnt)));
	printf("IP адрес источника:  ");
	cnt = 0;
	while(cnt < 3) {
		printf("%i.", (*(uint8_t*)(Buf + _udp_ipaddr_from + cnt)));
		cnt++;
	}
	printf("%i\n", (*(uint8_t*)(Buf + _udp_ipaddr_from + cnt)));
	printf("IP адрес приёмника:  ");
	cnt = 0;
	while(cnt < 3) {
		printf("%i.", (*(uint8_t*)(Buf + _udp_ipaddr_to + cnt)));
		cnt++;
	}
	printf("%i\n", (*(uint8_t*)(Buf + _udp_ipaddr_to + cnt)));
	sprintf(&strIP[0],"%i.%i.%i.%i",(*(uint8_t*)(Buf + _udp_ipaddr_to)), (*(uint8_t*)(Buf + _udp_ipaddr_to + 1)),
	(*(uint8_t*)(Buf + _udp_ipaddr_to + 2)), (*(uint8_t*)(Buf + _udp_ipaddr_to + 3)));
	printf("Протокол:            ");
	switch((*(uint8_t*)(Buf + _prot))) {
		case _prot_UDP:
			printf("UDP(%02X)\n", (*(uint8_t*)(Buf + _prot)));
			port = (*(uint8_t*)(Buf + _udp_port_to + 1)) | (uint16_t)((*(uint8_t*)(Buf + _udp_port_to)) << 8);
			printf("Порт приёмника:      %i\n", port);
			mport = port;
			break;
		case _prot_TCP:
			printf("TCP(%02X)\n", (*(uint8_t*)(Buf + _prot)));
			port = (*(uint8_t*)(Buf + _udp_port_to + 1)) | (uint16_t)((*(uint8_t*)(Buf + _udp_port_to)) << 8);
			printf("Порт приёмника:      %i\n", port);
			mport = port;
			break;
		default:
			break;
	}
	//
	cnt = 0;
	while(cnt < szBuf) {
		if(memcmp(Buf + cnt, &datastart[0], sizeof(datastart)) == 0)
			break;
		cnt++;
	}
	memcpy(outBuf, Buf + cnt, szBuf - cnt);
	return szBuf - cnt;
}

