//tcpc.c

#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include "config.h"
#include "tcpc.h"

int	client;

int TcpConnect(char *strIP, int port)
{
	int res;
	struct sockaddr_in min_clientaddr;
	client = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if(client < 0) {
		//#if(_debug2 > 0)
		printf("Create socket error!\n");
		//#endif
                return -1;
	}
	min_clientaddr.sin_family = AF_INET;
	min_clientaddr.sin_addr.s_addr = inet_addr(strIP);
        min_clientaddr.sin_port = htons(TCPPORT);
	//#if(_debug2 > 0)
	printf("TCPconnect: %s:%i\n", inet_ntoa(min_clientaddr.sin_addr), TCPPORT);
	//#endif
	res = connect(client, (struct sockaddr_in *)&min_clientaddr, sizeof(min_clientaddr));
	if(res < 0) {
		//#if(_debug2 > 0)
		printf("Connect error: %i !\n", res);
		//#endif
		return -2;
	}
	//#if(_debug2 > 0)
	printf("TCPconnected: %s !\n", inet_ntoa(min_clientaddr.sin_addr));
	//#endif
	//
	return 0;
}

void TcpDisconnet(void)
{
	close(client);
}

//
int TcpLoop(uint8_t *datas, int dlen)
{
	//int mlsock = lsock;
	int res;
	int iRC                     = 0;
        int iReceiveStatus          = 0;
	int iStillToReceive         = szbuff;
	struct timeval 	ReceiveTimeout;
	fd_set 		fds;
	uint8_t	Buffer[szbuff];
	uint8_t * pBuffer = &Buffer[0];
        int 		iSC 		= 0;
        int 		iSendStatus 	= 0;
        struct timeval 	SendTimeout;
        //fd_set 		fds;
	//int iMessageLength = sizeof(tstbuf);
	//#if(_debug2 > 0)
	int cnt, cnt2, cnt3 = 0;
	printf("Loop...\n\n");
	//#endif
	while(cnt3 == 0) {
		//установка величины таймаута
        	SendTimeout.tv_sec  = 0;
        	SendTimeout.tv_usec = _wSOCKET_TIMEOUT_;
        	FD_ZERO(&fds);
        	FD_SET(client, &fds);
                iSC = select(client + 1, NULL, &fds, NULL, &SendTimeout);
		if(!iSC) {
			#if(_debug2 > 0)
			printf("Send Timeout\n\n");
			#endif
                        break; //таймаут
		}
                if(iSC < 0) {
			#if(_debug2 > 0)
			printf("Send Error\n\n");
			#endif
                        break; //ошибка
		}
		iSendStatus = send(client, datas, dlen, 0);
		/*switch(cmd) {
			case 0: //выключение
				iMessageLength = sizeof(tstoff);
				iSendStatus = send(mlsock, &tstoff[0], iMessageLength, 0);
				break;
			case 1: //включение
				iMessageLength = sizeof(tston2);
				iSendStatus = send(mlsock, &tston2[0], iMessageLength, 0);
				break;
			default:
				goto exit;
		}*/
		if(iSendStatus < 0) {
			break;
		}
		//установка величины таймаута
		FD_ZERO(&fds);
                FD_SET(client, &fds);
                ReceiveTimeout.tv_sec  = 0;
                ReceiveTimeout.tv_usec = _rSOCKET_TIMEOUT_;
		iRC = select(client + 1, &fds, NULL, NULL, &ReceiveTimeout);
		//выход по таймауту
                if(!iRC) {
			#if(_debug2 > 0)
			printf("Recv Timeout\n\n");
			#endif
			break;
		}
		//произошла какая то ошибка
                if(iRC < 0) {
			#if(_debug2 > 0)
			printf("Recv Error\n\n");
			#endif
                        break;
		}
		iReceiveStatus = recv(client, (char*)(pBuffer), iStillToReceive, 0);
		if(iReceiveStatus >  0) {
			pBuffer += iReceiveStatus;
                        iStillToReceive -= iReceiveStatus;
		}
		else if(iReceiveStatus < 0) {
			break;
		}
		#if(_debug2 > 0)
		printf("RcvLen: %i\n", iReceiveStatus);
		cnt = 0;
		cnt2 = 0;
		while(cnt < iReceiveStatus) {
			if(!(cnt2 < 0x10)) {
				printf("\n");
				cnt2 = 0;
			}
			printf("%02X ", Buffer[cnt]);
			cnt2++;
			cnt++;
		}
		printf("\n\n");
		#endif
		//
		sleep(2);
		cnt3++;
	}
exit:	close(client);
}
